


FIG2DEV(1)               USER COMMANDS                 FIG2DEV(1)



NAME
     fig2dev - translates Fig code to various graphics languages


SYNOPSIS
     fig2dev -L language [ -m mag ] [ -f font ] [ -s  fsize  ]  [
     other options ] [ fig-file [ out-file ] ]


DESCRIPTION
     Fig2dev translates fig code in the named fig-file  into  the
     specified  graphics  language and puts them in out-file. The
     default fig-file and out-file are standard input  and  stan-
     dard output, respectively

     Fig (Facility for Interactive Generation of  figures)  is  a
     screen-oriented tool which allows the user to draw and mani-
     pulate objects interactively.  Various versions of  Fig  run
     under the Suntools/Sunview window environment and under ver-
     sion 11 of the X Windows System.  Fig2dev is compatible with
     Fig versions 1.3, 1.4-TFX, and 2.0.


OPTIONS
     -L   Set the output graphics language.  Valid languages  are
          box,  epic,  eepic, eepicemu, latex, null, pic, pictex,
          and ps.

     -m   Set the magnification at which the figure  is  rendered
          to mag. The default is 1.0.

     -f   Set the default font used for text objects to font. The
          default  is Roman; the format of this option depends on
          the graphics language in use.  In TeX-based  languages,
          the  font  is the base of the name given in lfonts.tex,
          for instance In PostScript, it is any font  name  known
          to the printer or interpreter.

     -s   Set the default font size (in points) for text  objects
          to  fsize. The default is 11*mag, and thus is scaled by
          the -m option.  If there is  no  scaling,  the  default
          font is eleven point Roman."

     other options
          The other options are specific to the choice of  graph-
          ics language, as described below.


EPIC OPTIONS
     EPIC is an enhancement to LaTeX picture drawing environment.
     It  was  developed  by Sunil Podar of Department of Computer
     Science in S.U.N.Y at Stony Brook.

     EEPIC is an extension to  EPIC  and  LaTeX  picture  drawing
     environment  which  uses tpic specials as a graphics mechan-
     ism.  It was written by Conrad Kwok of Division of  Computer
     Science at University of California, Davis.

     EEPIC-EMU is an EEPIC emulation package which does  not  use
     tpic specials.

     -S   Set the scale to which the figure  is  rendered.   This
          option automatically sets the magnification and size to
          scale / 12 and scale respectively.

     -l   Use "\thicklines" when width of the line is wider  than
          lwidth. The default is 2.

     -v   Include comments in the output file.

     -P   Generate a complete LaTeX file.  In  other  words,  the
          ouput  file  can  be  formatted  without  requiring any
          changes. The additional text inserted in the  beginning
          and  at the end of the file is controlled by the confi-
          guration parameter "Preamble" and "Postamble".

     -W   Enable variable line width

     -w   Disable variable line width. Only "\thicklines"  and/or
          "\thinlines"  commands  will be generated in the output
          file.

     When variable line width  option  is  enabled,  "\thinlines"
     command  is  still used when line width is less than LineTh-
     ick. One potential problem is that the width of "\thinlines"
     is  0.4pt  but  the  resolution of Fig is 1/80 inch (approx.
     1pt). If LineThick is set to 2, normal lines will  be  drawn
     in  0.4pt wide lines but the next line width is already 2pt.
     One possible solution is to set LineThick to 1 and  set  the
     width  of  the  those  lines you want to be drawn in "\thin-
     lines"  to 0.

     Due  to  this  problem,  Varible  line  width  VarWidth   is
     defaulted to be false.


LATEX OPTIONS
     -l   Sets the threshold between LaTeX thin and  thick  lines
          to  lwidth  pixels.   LaTeX supports only two different
          line width: \thinlines and \thicklines.  Lines of width
          greater  than  lwidth  pixels are drawn as \thicklines.
          Also affects the size of dots  in  dotted  line  style.
          The default is 0.

     -d   Set a seperate magnification for  the  length  of  line
          dashes to dmag.

     -v   Verbose mode.

     LaTeX cannot accurately represent all the  graphics  objects
     which  can  be  described by Fig.  For example, the possible
     slopes which lines may have are limited.  Some objects, such
     as spline curves, cannot be drawn at all.  Fig2latex chooses
     the closest possible line slope, and prints  error  messages
     when objects cannot be drawn accurately


PICTEX OPTIONS
     -p Set the symbol used by  PiCTeX  for  plotting  lines  and
     curves to psymbol. The default is "\sevrm ."

     -l   Set the width of any rules used to draw lines and boxes
          within the picture to lwidth. The default is "0.7pt".

     In order to include PiCTeX pictures into a document,  it  is
     necessary to load the PiCTeX macros.

     PiCTeX uses TeX  integer  register  arithmetic  to  generate
     curves,  and  so  it  is  very slow.  PiCTeX draws curves by
     \put-ing the psymbol repeatedly, and  so  requires  a  large
     amount  of  TeX's  internal  memory, and generates large DVI
     files.  The size of TeX's memory limits the number  of  plot
     symbols in a picture.  As a result, it is best to use PiCTeX
     to generate small pictures.


POSTSCRIPT OPTIONS
     -c   option centers the figure on the page.   The  centering
          may  not be accurate if there are texts in the fig_file
          that extends too far to the right of other objects.

     -P   indicates that the figure describes a full  page  which
          will  not  necessarily be inserted into a document, but
          can be sent directly to a  PS  printer.   This  ensures
          that  a  showpage command is inserted at the end of the
          figure, and inhibits translation of the figure  coordi-
          nate system.

     -l   Rotate figure to landscape mode.


SEE ALSO
     [x]fig(1), pic(1) pic2fig(1), transfig(1)

AUTHORS
     Micah Beck (beck@svax.cs.cornell.edu)
     Cornell University
     May 7 1989

     and Frank Schmuck (then of Cornell University)
     and Conrad Kwok (then of the U.C. Davis).

     Modified from f2p (fig to PIC), by the author of Fig
     Supoj Sutanthavibul (supoj@sally.utexas.edu)
     University of Texas at Austin.
