


TRANSFIG(1)              USER COMMANDS                TRANSFIG(1)



NAME
     transfig - creates a makefile for portable LaTeX figures

SYNOPSIS
     transfig [ -L language ] [ -M makefile ] [ -T  texfile  ]  [
     control_specs figfile ... ] ...]

DESCRIPTION
     Transfig creates a makefile to translate  figures  described
     in  Fig  code,  PostScript,  or  PIC  into a specified LaTeX
     graphics language.  PostScript and PIC files are  identified
     by the suffixes ".ps" and ".pic" respectively; Fig files can
     be specified either with or  without  the  suffix  ".fig"  .
     Transfig  also  creates  a TeX macro file appropriate to the
     target language.

OPTIONS
     The language specifier must be either epic, eepic, eepicemu,
     latex,  pictex,  ps,  psfig,  tpic,  or null.  The specifier
     psfig is like the ps specifier, except that it make  use  of
     the  psfig macro package.  The specifier null results in the
     figures being replaced by empty  boxes  of  the  appropriate
     size.  If no language is specified, epic is the default.

     The names of the makefile and TeX macro file can be set with
     the -M and -T options.  The default names are "Makefile" and
     "transfig.tex", respectively.

     Control specifiers are

     -m mag
          set the magnification at which the figure  is  rendered
          (default 1.0).

     -f font
          set the default  font  family  used  for  text  objects
          (default "cmr").

     -s fontsize
          set the default font size (in points) for text  objects
          (default 11*mag).

     If there is  no  scaling,  the  default  font  is  "\elvrm".
     Language  and  control  specifiers may occur more than once;
     they affect the translation of files which appear  to  their
     right  in the argument list. If no files are specified, then
     "*.fig" is assumed.

SEE ALSO
     fig(1), fig2dev(1), pic(1), pic2fig(1),

AUTHOR
     Micah Beck (beck@svax.cs.cornell.edu)
