/*
**	SpecialHost for PasTeX
**
**	Copyright  by Olaf Barthel & Georg Hemann
*/

#include "Global.h"

struct ExecBase			*SysBase;
struct DosLibrary		*DOSBase;

struct IntuitionBase		*IntuitionBase;
struct GfxBase			*GfxBase;
struct Library			*IconBase,
				*GadToolsBase,
				*IFFParseBase,
				*UtilityBase,
				*AslBase,
/*
				*MathBase,
				*MathTransBase,
*/
				*MathIeeeDoubBasBase,
				*MathIeeeDoubTransBase,

				*MUIMasterBase,
				*DataTypesBase;

struct Process			*ThisProcess;
APTR				 OldPtr;

APTR				 Pool;

struct List			 MessageList;

struct MsgPort			*MainPort;

UBYTE				 Filter[256];

APTR				 AP_Application,
				 WI_Main,
				 CY_Transfer,
				 CY_Render,
				 CM_Invert,
				 ST_BaseDPI,
				 LV_Messages,
				 GA_Gauge,
				 BT_Jump,
				 BT_Show,
				 BT_Clear;

struct Screen			*PubScreen;

struct Process			*Father;
BOOL				 InvertChanged	= FALSE,
				 UseGUI		= TRUE;

struct config_struct Configuration =
{
	CONFIG_FILE_MAGIC,
	CONFIG_FILE_VERSION,
	TRUE,
	FALSE,
	100,
	DRAW_IN_MEM,
	0,0,
	0,0,
	0,0,
	FALSE,
	0,0,0,0,0,0,0,0,0
};

#define TOGGLE	CHECKIT|TOGGLESELECT

struct NewMenu MenuTemplate[] =
{
	{ NM_TITLE, "Project",			 0 ,	0,	0,	(APTR)0},
	{  NM_ITEM, "Load settings",		"O",	0,	0,	(APTR)MEN_OPEN},
	{  NM_ITEM, "Save settings",		"W",	0,	0,	(APTR)MEN_SAVE},
	{  NM_ITEM, NM_BARLABEL,		 0 ,	0,	0,	(APTR)0},
	{  NM_ITEM, "Use public screen",	"U",	TOGGLE,	0,	(APTR)MEN_PUBSCREEN},
	{  NM_ITEM, NM_BARLABEL,		 0 ,	0,	0,	(APTR)0},
	{  NM_ITEM, "About...",			"?",	0,	0,	(APTR)MEN_ABOUT},
	{  NM_ITEM, NM_BARLABEL,		 0 ,	0,	0,	(APTR)0},
	{  NM_ITEM, "Quit",			"Q",	0,	0,	(APTR)MEN_QUIT},
	{ NM_END,   0,				 0 ,	0,	0,	(APTR)0}
};

STRPTR CYA_Transfer[] =
{
	"Image in memory",
	"Image on disk",
	" No image ",
	NULL
};

STRPTR CYA_Render[] =
{
	" No modification ",
	"Draw a frame",
	"Clear image",
	NULL
};

UBYTE OrderedBckBrick[256] =
{
	0xFF,0xE0,0xC3,0xA8,0x8F,0x78,0x63,0x50,0x3F,0x30,0x23,0x18,0x0F,0x08,0x03,0x01,
	0xEF,0xFE,0xDF,0xC2,0xA7,0x8E,0x77,0x62,0x4F,0x3E,0x2F,0x22,0x17,0x0E,0x07,0x02,
	0xD1,0xEE,0xFD,0xDE,0xC1,0xA6,0x8D,0x76,0x61,0x4E,0x3D,0x2E,0x21,0x16,0x0D,0x06,
	0xB5,0xD0,0xED,0xFC,0xDD,0xC0,0xA5,0x8C,0x75,0x60,0x4D,0x3C,0x2D,0x20,0x15,0x0C,
	0x9B,0xB4,0xCF,0xEC,0xFB,0xDC,0xBF,0xA4,0x8B,0x74,0x5F,0x4C,0x3B,0x2C,0x1F,0x14,
	0x83,0x9A,0xB3,0xCE,0xEB,0xFA,0xDB,0xBE,0xA3,0x8A,0x73,0x5E,0x4B,0x3A,0x2B,0x1E,
	0x6D,0x82,0x99,0xB2,0xCD,0xEA,0xF9,0xDA,0xBD,0xA2,0x89,0x72,0x5D,0x4A,0x39,0x2A,
	0x59,0x6C,0x81,0x98,0xB1,0xCC,0xE9,0xF8,0xD9,0xBC,0xA1,0x88,0x71,0x5C,0x49,0x38,
	0x47,0x58,0x6B,0x80,0x97,0xB0,0xCB,0xE8,0xF7,0xD8,0xBB,0xA0,0x87,0x70,0x5B,0x48,
	0x37,0x46,0x57,0x6A,0x7F,0x96,0xAF,0xCA,0xE7,0xF6,0xD7,0xBA,0x9F,0x86,0x6F,0x5A,
	0x29,0x36,0x45,0x56,0x69,0x7E,0x95,0xAE,0xC9,0xE6,0xF5,0xD6,0xB9,0x9E,0x85,0x6E,
	0x1D,0x28,0x35,0x44,0x55,0x68,0x7D,0x94,0xAD,0xC8,0xE5,0xF4,0xD5,0xB8,0x9D,0x84,
	0x13,0x1C,0x27,0x34,0x43,0x54,0x67,0x7C,0x93,0xAC,0xC7,0xE4,0xF3,0xD4,0xB7,0x9C,
	0x0B,0x12,0x1B,0x26,0x33,0x42,0x53,0x66,0x7B,0x92,0xAB,0xC6,0xE3,0xF2,0xD3,0xB6,
	0x05,0x0A,0x11,0x1A,0x25,0x32,0x41,0x52,0x65,0x7A,0x91,0xAA,0xC5,0xE2,0xF1,0xD2,
	0x01,0x04,0x09,0x10,0x19,0x24,0x31,0x40,0x51,0x64,0x79,0x90,0xA9,0xC4,0xE1,0xF0
};

UBYTE OrderedFwdBrick[256] =
{
	0x01,0x04,0x09,0x10,0x19,0x24,0x31,0x40,0x51,0x64,0x79,0x90,0xA9,0xC4,0xE1,0xF0,
	0x05,0x0A,0x11,0x1A,0x25,0x32,0x41,0x52,0x65,0x7A,0x91,0xAA,0xC5,0xE2,0xF1,0xD2,
	0x0B,0x12,0x1B,0x26,0x33,0x42,0x53,0x66,0x7B,0x92,0xAB,0xC6,0xE3,0xF2,0xD3,0xB6,
	0x13,0x1C,0x27,0x34,0x43,0x54,0x67,0x7C,0x93,0xAC,0xC7,0xE4,0xF3,0xD4,0xB7,0x9C,
	0x1D,0x28,0x35,0x44,0x55,0x68,0x7D,0x94,0xAD,0xC8,0xE5,0xF4,0xD5,0xB8,0x9D,0x84,
	0x29,0x36,0x45,0x56,0x69,0x7E,0x95,0xAE,0xC9,0xE6,0xF5,0xD6,0xB9,0x9E,0x85,0x6E,
	0x37,0x46,0x57,0x6A,0x7F,0x96,0xAF,0xCA,0xE7,0xF6,0xD7,0xBA,0x9F,0x86,0x6F,0x5A,
	0x47,0x58,0x6B,0x80,0x97,0xB0,0xCB,0xE8,0xF7,0xD8,0xBB,0xA0,0x87,0x70,0x5B,0x48,
	0x59,0x6C,0x81,0x98,0xB1,0xCC,0xE9,0xF8,0xD9,0xBC,0xA1,0x88,0x71,0x5C,0x49,0x38,
	0x6D,0x82,0x99,0xB2,0xCD,0xEA,0xF9,0xDA,0xBD,0xA2,0x89,0x72,0x5D,0x4A,0x39,0x2A,
	0x83,0x9A,0xB3,0xCE,0xEB,0xFA,0xDB,0xBE,0xA3,0x8A,0x73,0x5E,0x4B,0x3A,0x2B,0x1E,
	0x9B,0xB4,0xCF,0xEC,0xFB,0xDC,0xBF,0xA4,0x8B,0x74,0x5F,0x4C,0x3B,0x2C,0x1F,0x14,
	0xB5,0xD0,0xED,0xFC,0xDD,0xC0,0xA5,0x8C,0x75,0x60,0x4D,0x3C,0x2D,0x20,0x15,0x0C,
	0xD1,0xEE,0xFD,0xDE,0xC1,0xA6,0x8D,0x76,0x61,0x4E,0x3D,0x2E,0x21,0x16,0x0D,0x06,
	0xEF,0xFE,0xDF,0xC2,0xA7,0x8E,0x77,0x62,0x4F,0x3E,0x2F,0x22,0x17,0x0E,0x07,0x02,
	0xFF,0xE0,0xC3,0xA8,0x8F,0x78,0x63,0x50,0x3F,0x30,0x23,0x18,0x0F,0x08,0x03,0x01
};

UBYTE OrderedHalftone[256] =
{
	0x80,0x8A,0x9A,0xAE,0xAC,0x98,0x88,0x86,0x7F,0x75,0x65,0x51,0x53,0x67,0x77,0x79,
	0x8C,0xBC,0xC8,0xDA,0xD8,0xC6,0xBA,0x96,0x73,0x43,0x37,0x25,0x27,0x39,0x45,0x69,
	0x9C,0xCA,0xE4,0xEC,0xE6,0xE0,0xC4,0xA6,0x63,0x35,0x1B,0x17,0x19,0x1F,0x3B,0x59,
	0xB0,0xDC,0xF6,0xF8,0xFA,0xE8,0xD6,0xAA,0x4F,0x23,0x09,0x07,0x05,0x13,0x29,0x55,
	0xB2,0xDE,0xF4,0xFE,0xFC,0xEA,0xD4,0xA8,0x4D,0x21,0x0B,0x01,0x03,0x15,0x2B,0x57,
	0x9E,0xCC,0xEE,0xF2,0xF0,0xE2,0xC2,0xA4,0x61,0x33,0x11,0x0D,0x0F,0x1D,0x3D,0x5B,
	0x8E,0xBE,0xCE,0xD0,0xD2,0xC0,0xB8,0x94,0x71,0x41,0x31,0x2F,0x2D,0x3F,0x47,0x6B,
	0x82,0x90,0xA0,0xB4,0xB6,0xA2,0x92,0x84,0x7D,0x6F,0x5F,0x4B,0x49,0x5D,0x6D,0x7B,
	0x7E,0x74,0x64,0x50,0x52,0x66,0x76,0x78,0x81,0x8B,0x9B,0xAF,0xAD,0x99,0x89,0x87,
	0x72,0x42,0x36,0x24,0x26,0x38,0x44,0x68,0x8D,0xBD,0xC9,0xDB,0xD9,0xC7,0xBB,0x97,
	0x62,0x34,0x1A,0x16,0x18,0x1E,0x3A,0x58,0x9D,0xCB,0xE5,0xF3,0xF1,0xE1,0xC5,0xA7,
	0x4E,0x22,0x08,0x06,0x04,0x12,0x28,0x54,0xB1,0xDD,0xF5,0xFE,0xFD,0xEF,0xD7,0xAB,
	0x4A,0x20,0x0A,0x00,0x02,0x14,0x2A,0x56,0xB3,0xDF,0xF7,0xF9,0xFB,0xED,0xD5,0xA9,
	0x60,0x32,0x10,0x0C,0x0E,0x1C,0x3C,0x5A,0x9F,0xCD,0xE7,0xE9,0xEB,0xE3,0xC3,0xA5,
	0x70,0x40,0x30,0x2E,0x2C,0x3E,0x46,0x6A,0x8F,0xBF,0xCF,0xD1,0xD3,0xC1,0xB9,0x95,
	0x7C,0x6E,0x5E,0x4A,0x48,0x5C,0x6C,0x7A,0x83,0x91,0xA1,0xB5,0xB7,0xA3,0x93,0x85
};

UBYTE OrderedVanilla[256] =
{
	0x01,0xEB,0x3B,0xDB,0x0F,0xE7,0x37,0xD7,0x02,0xE8,0x38,0xD8,0x0C,0xE4,0x34,0xD4,
	0x81,0x41,0xBB,0x7B,0x8F,0x4F,0xB7,0x77,0x82,0x42,0xB8,0x78,0x8C,0x4C,0xB4,0x74,
	0x21,0xC1,0x11,0xFB,0x2F,0xCF,0x1F,0xF7,0x22,0xC2,0x12,0xF8,0x2C,0xCC,0x1C,0xF4,
	0xA1,0x61,0x91,0x51,0xAF,0x6F,0x9F,0x5F,0xA2,0x62,0x92,0x52,0xAC,0x6C,0x9C,0x5C,
	0x09,0xE1,0x31,0xD1,0x05,0xEF,0x3F,0xDF,0x0A,0xE2,0x32,0xD2,0x06,0xEC,0x3C,0xDC,
	0x89,0x49,0xB1,0x71,0x85,0x45,0xBF,0x7F,0x8A,0x4A,0xB2,0x72,0x86,0x46,0xBC,0x7C,
	0x29,0xC9,0x19,0xF1,0x25,0xC5,0x15,0xFE,0x2A,0xCA,0x1A,0xF2,0x26,0xC6,0x16,0xFC,
	0xA9,0x69,0x99,0x59,0xA5,0x65,0x95,0x55,0xAA,0x6A,0x9A,0x5A,0xA6,0x66,0x96,0x56,
	0x03,0xE9,0x39,0xD9,0x0D,0xE5,0x35,0xD5,0x00,0xEA,0x3A,0xDA,0x0E,0xE6,0x36,0xD6,
	0x83,0x43,0xB9,0x79,0x8D,0x4D,0xB5,0x75,0x80,0x40,0xBA,0x7A,0x8E,0x4E,0xB6,0x76,
	0x23,0xC3,0x13,0xF9,0x2D,0xCD,0x1D,0xF5,0x20,0xC0,0x10,0xFA,0x2E,0xCE,0x1E,0xF6,
	0xA3,0x63,0x93,0x53,0xAD,0x6D,0x9D,0x5D,0xA0,0x60,0x90,0x50,0xAE,0x6E,0x9E,0x5E,
	0x0B,0xE3,0x33,0xD3,0x07,0xED,0x3D,0xDD,0x08,0xE0,0x30,0xD0,0x04,0xEE,0x3E,0xDE,
	0x8B,0x4B,0xB3,0x73,0x87,0x47,0xBD,0x7D,0x88,0x48,0xB0,0x70,0x84,0x44,0xBE,0x7E,
	0x2B,0xCB,0x1B,0xF3,0x27,0xC7,0x17,0xFD,0x28,0xC8,0x18,0xF0,0x24,0xC4,0x14,0xFE,
	0xAB,0x6B,0x9B,0x5B,0xA7,0x67,0x97,0x57,0xA8,0x68,0x98,0x58,0xA4,0x64,0x94,0x54
};

UBYTE OrderedHexagonalCluster[256] =
{
	0xEF,0xEF,0xAF,0x21,0x01,0x11,0x91,0xCC,0xFC,0xEC,0xAC,0x22,0x02,0x12,0x92,0xCF,
	0xDF,0x7F,0x3F,0x6B,0xBB,0x5B,0x4B,0x8C,0xDC,0x7C,0x3C,0x68,0xB8,0x58,0x48,0x8F,
	0x0F,0x1F,0x9F,0xCB,0xFB,0xEB,0xAB,0x2C,0x0C,0x1C,0x9C,0xC8,0xF8,0xE8,0xA8,0x2F,
	0xB7,0x57,0x47,0x8B,0xDB,0x7B,0x3B,0x64,0xB4,0x54,0x44,0x88,0xD8,0x78,0x38,0x67,
	0xF7,0xE7,0xA7,0x2B,0x0B,0x1B,0x9B,0xC4,0xF4,0xE4,0xA4,0x28,0x08,0x18,0x98,0xC7,
	0xD7,0x77,0x37,0x63,0xB3,0x53,0x43,0x84,0xD4,0x74,0x34,0x60,0xB0,0x50,0x40,0x87,
	0x07,0x17,0x97,0xC3,0xF3,0xE3,0xA3,0x24,0x04,0x14,0x94,0xC0,0xF0,0xE0,0xA0,0x27,
	0xBD,0x5D,0x4D,0x83,0xD3,0x73,0x33,0x6E,0xBE,0x5E,0x4E,0x80,0xD0,0x70,0x30,0x6D,
	0xFD,0xED,0xAD,0x23,0x03,0x13,0x93,0xCE,0xFE,0xEE,0xAE,0x20,0x00,0x10,0x90,0xCD,
	0xDD,0x7D,0x3D,0x69,0xB9,0x59,0x49,0x8E,0xDE,0x7E,0x3E,0x6A,0xBA,0x5A,0x4A,0x8D,
	0x0D,0x1D,0x9D,0xC9,0xF9,0xE9,0xA9,0x2E,0x0E,0x1E,0x9E,0xCA,0xFA,0xEA,0xAA,0x2D,
	0xB5,0x55,0x45,0x89,0xD9,0x79,0x39,0x66,0xB6,0x56,0x46,0x8A,0xDA,0x7A,0x3A,0x65,
	0xF5,0xE5,0xA5,0x29,0x09,0x19,0x99,0xC6,0xF6,0xE6,0xA6,0x2A,0x0A,0x1A,0x9A,0xC5,
	0xD5,0x75,0x35,0x61,0xB1,0x51,0x41,0x86,0xD6,0x76,0x36,0x62,0xB2,0x52,0x42,0x85,
	0x05,0x15,0x95,0xC1,0xF1,0xE1,0xA1,0x26,0x06,0x16,0x96,0xC2,0xF2,0xE2,0xA2,0x25,
	0xBF,0x5F,0x4F,0x81,0xD1,0x71,0x31,0x6C,0xBC,0x5C,0x4C,0x82,0xD2,0x72,0x32,0x6F
};

UBYTE OrderedSpiralDot[256] =
{
	0xD2,0xD3,0xD4,0xD5,0xD6,0xD7,0xD8,0xD9,0xDA,0xDB,0xDC,0xDD,0xDE,0xDF,0xE0,0xE1,
	0xD1,0x9C,0x9D,0x9E,0x9F,0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xA8,0xA9,0xE2,
	0xD0,0x9B,0x6E,0x6F,0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x78,0x79,0xAA,0xE3,
	0xCF,0x9A,0x6D,0x48,0x49,0x4A,0x4B,0x4C,0x4D,0x4E,0x4F,0x50,0x51,0x7A,0xAB,0xE4,
	0xCE,0x99,0x6C,0x47,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F,0x30,0x31,0x52,0x7B,0xAC,0xE5,
	0xCD,0x98,0x6B,0x46,0x29,0x14,0x15,0x16,0x17,0x18,0x19,0x32,0x53,0x7C,0xAD,0xE6,
	0xCC,0x97,0x6A,0x45,0x28,0x13,0x06,0x07,0x08,0x09,0x1A,0x33,0x54,0x7D,0xAE,0xE7,
	0xCB,0x96,0x69,0x44,0x27,0x12,0x05,0x00,0x01,0x0A,0x1B,0x34,0x55,0x7E,0xAF,0xE8,
	0xCA,0x95,0x68,0x43,0x26,0x11,0x04,0x03,0x02,0x0B,0x1C,0x35,0x56,0x7F,0xB0,0xE9,
	0xC9,0x94,0x67,0x42,0x25,0x10,0x0F,0x0E,0x0D,0x0C,0x1D,0x36,0x57,0x80,0xB1,0xEA,
	0xC8,0x93,0x66,0x41,0x24,0x23,0x22,0x21,0x20,0x1F,0x1E,0x37,0x58,0x81,0xB2,0xEB,
	0xC7,0x92,0x65,0x40,0x3F,0x3E,0x3D,0x3C,0x3B,0x3A,0x39,0x38,0x59,0x82,0xB3,0xEC,
	0xC6,0x91,0x64,0x63,0x62,0x61,0x60,0x5F,0x5E,0x5D,0x5C,0x5B,0x5A,0x83,0xB4,0xED,
	0xC5,0x90,0x8F,0x8E,0x8D,0x8C,0x8B,0x8A,0x89,0x88,0x87,0x86,0x85,0x84,0xB5,0xEE,
	0xC4,0xC3,0xC2,0xC1,0xC0,0xBF,0xBE,0xBD,0xBC,0xBB,0xBA,0xB9,0xB8,0xB7,0xB6,0xEF,
	0xFE,0xFE,0xFD,0xFC,0xFB,0xFA,0xF9,0xF8,0xF7,0xF6,0xF5,0xF4,0xF3,0xF2,0xF1,0xF0
};

UBYTE OrderedHorizontal[256] =
{
	0xED,0xEB,0xE9,0xE7,0xE5,0xE3,0xE1,0xDF,0xDD,0xDE,0xE0,0xE2,0xE4,0xE6,0xE8,0xEA,
	0xEC,0xCB,0xC9,0xC7,0xC5,0xC3,0xC1,0xBF,0xBD,0xBB,0xBC,0xBE,0xC0,0xC2,0xC4,0xC6,
	0xC8,0xCA,0xA9,0xA7,0xA5,0xA3,0xA1,0x9F,0x9D,0x9B,0x99,0x9A,0x9C,0x9E,0xA0,0xA2,
	0xA4,0xA6,0xA8,0x87,0x85,0x83,0x81,0x7F,0x7D,0x7B,0x79,0x77,0x78,0x7A,0x7C,0x7E,
	0x80,0x82,0x84,0x86,0x65,0x63,0x61,0x5F,0x5D,0x5B,0x59,0x57,0x55,0x56,0x58,0x5A,
	0x5C,0x5E,0x60,0x62,0x64,0x43,0x41,0x3F,0x3D,0x3B,0x39,0x37,0x35,0x33,0x34,0x36,
	0x38,0x3A,0x3C,0x3E,0x40,0x42,0x21,0x1F,0x1D,0x1B,0x19,0x17,0x15,0x13,0x11,0x12,
	0x14,0x16,0x18,0x1A,0x1C,0x1E,0x20,0x10,0x0E,0x0C,0x0A,0x08,0x06,0x04,0x02,0x00,
	0x01,0x03,0x05,0x07,0x09,0x0B,0x0D,0x0F,0x32,0x30,0x2E,0x2C,0x2A,0x28,0x26,0x24,
	0x22,0x23,0x25,0x27,0x29,0x2B,0x2D,0x2F,0x31,0x54,0x52,0x50,0x4E,0x4C,0x4A,0x48,
	0x46,0x44,0x45,0x47,0x49,0x4B,0x4D,0x4F,0x51,0x53,0x76,0x74,0x72,0x70,0x6E,0x6C,
	0x6A,0x68,0x66,0x67,0x69,0x6B,0x6D,0x6F,0x71,0x73,0x75,0x98,0x96,0x94,0x92,0x90,
	0x8E,0x8C,0x8A,0x88,0x89,0x8B,0x8D,0x8F,0x91,0x93,0x95,0x97,0xBA,0xB8,0xB6,0xB4,
	0xB2,0xB0,0xAE,0xAC,0xAA,0xAB,0xAD,0xAF,0xB1,0xB3,0xB5,0xB7,0xB9,0xDC,0xDA,0xD8,
	0xD6,0xD4,0xD2,0xD0,0xCE,0xCC,0xCD,0xCF,0xD1,0xD3,0xD5,0xD7,0xD9,0xDB,0xFE,0xFC,
	0xFA,0xF8,0xF6,0xF4,0xF2,0xF0,0xEE,0xEF,0xF1,0xF3,0xF5,0xF7,0xF9,0xFB,0xFD,0x00
};

UBYTE OrderedBckBrick8[256] =
{
        0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,
        0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,
        0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,
        0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,
        0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,
        0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,
        0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,
        0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,
        0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,
        0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,
        0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,
        0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,
        0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,
        0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,
        0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,
        0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF
};

UBYTE OrderedBckBrick4[256] =
{
        0xFF,0xC3,0x8F,0x63,0x3F,0x23,0x0F,0x03,0xFF,0xC3,0x8F,0x63,0x3F,0x23,0x0F,0x03,
        0xDF,0xFB,0xBF,0x8B,0x5F,0x3B,0x1F,0x0B,0xDF,0xFB,0xBF,0x8B,0x5F,0x3B,0x1F,0x0B,
        0xA7,0xDB,0xF7,0xBB,0x87,0x5B,0x37,0x1B,0xA7,0xDB,0xF7,0xBB,0x87,0x5B,0x37,0x1B,
        0x77,0xA3,0xD7,0xF3,0xB7,0x83,0x57,0x33,0x77,0xA3,0xD7,0xF3,0xB7,0x83,0x57,0x33,
        0x4F,0x73,0x9F,0xD3,0xEF,0xB3,0x7F,0x53,0x4F,0x73,0x9F,0xD3,0xEF,0xB3,0x7F,0x53,
        0x2F,0x4B,0x6F,0x9B,0xCF,0xEB,0xAF,0x7B,0x2F,0x4B,0x6F,0x9B,0xCF,0xEB,0xAF,0x7B,
        0x17,0x2B,0x47,0x6B,0x97,0xCB,0xE7,0xAB,0x17,0x2B,0x47,0x6B,0x97,0xCB,0xE7,0xAB,
        0x07,0x13,0x27,0x43,0x67,0x93,0xC7,0xE3,0x07,0x13,0x27,0x43,0x67,0x93,0xC7,0xE3,
        0xFF,0xC3,0x8F,0x63,0x3F,0x23,0x0F,0x03,0xFF,0xC3,0x8F,0x63,0x3F,0x23,0x0F,0x03,
        0xDF,0xFB,0xBF,0x8B,0x5F,0x3B,0x1F,0x0B,0xDF,0xFB,0xBF,0x8B,0x5F,0x3B,0x1F,0x0B,
        0xA7,0xDB,0xF7,0xBB,0x87,0x5B,0x37,0x1B,0xA7,0xDB,0xF7,0xBB,0x87,0x5B,0x37,0x1B,
        0x77,0xA3,0xD7,0xF3,0xB7,0x83,0x57,0x33,0x77,0xA3,0xD7,0xF3,0xB7,0x83,0x57,0x33,
        0x4F,0x73,0x9F,0xD3,0xEF,0xB3,0x7F,0x53,0x4F,0x73,0x9F,0xD3,0xEF,0xB3,0x7F,0x53,
        0x2F,0x4B,0x6F,0x9B,0xCF,0xEB,0xAF,0x7B,0x2F,0x4B,0x6F,0x9B,0xCF,0xEB,0xAF,0x7B,
        0x17,0x2B,0x47,0x6B,0x97,0xCB,0xE7,0xAB,0x17,0x2B,0x47,0x6B,0x97,0xCB,0xE7,0xAB,
        0x07,0x13,0x27,0x43,0x67,0x93,0xC7,0xE3,0x07,0x13,0x27,0x43,0x67,0x93,0xC7,0xE3
};

UBYTE OrderedFwdBrick8[256] =
{
        0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,
        0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,
        0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,
        0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,
        0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,
        0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,
        0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,
        0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,
        0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,
        0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,
        0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,
        0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,
        0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,0x1F,0x4F,0x9F,0xCF,
        0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,0x5F,0xAF,0xDF,0x6F,
        0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,0xBF,0xEF,0x7F,0x2F,
        0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F,0xFF,0x8F,0x3F,0x0F
};

UBYTE OrderedFwdBrick4[256] =
{
        0x07,0x13,0x27,0x43,0x67,0x93,0xC7,0xE3,0x07,0x13,0x27,0x43,0x67,0x93,0xC7,0xE3,
        0x17,0x2B,0x47,0x6B,0x97,0xCB,0xE7,0xAB,0x17,0x2B,0x47,0x6B,0x97,0xCB,0xE7,0xAB,
        0x2F,0x4B,0x6F,0x9B,0xCF,0xEB,0xAF,0x7B,0x2F,0x4B,0x6F,0x9B,0xCF,0xEB,0xAF,0x7B,
        0x4F,0x73,0x9F,0xD3,0xEF,0xB3,0x7F,0x53,0x4F,0x73,0x9F,0xD3,0xEF,0xB3,0x7F,0x53,
        0x77,0xA3,0xD7,0xF3,0xB7,0x83,0x57,0x33,0x77,0xA3,0xD7,0xF3,0xB7,0x83,0x57,0x33,
        0xA7,0xDB,0xF7,0xBB,0x87,0x5B,0x37,0x1B,0xA7,0xDB,0xF7,0xBB,0x87,0x5B,0x37,0x1B,
        0xDF,0xFB,0xBF,0x8B,0x5F,0x3B,0x1F,0x0B,0xDF,0xFB,0xBF,0x8B,0x5F,0x3B,0x1F,0x0B,
        0xFF,0xC3,0x8F,0x63,0x3F,0x23,0x0F,0x03,0xFF,0xC3,0x8F,0x63,0x3F,0x23,0x0F,0x03,
        0x07,0x13,0x27,0x43,0x67,0x93,0xC7,0xE3,0x07,0x13,0x27,0x43,0x67,0x93,0xC7,0xE3,
        0x17,0x2B,0x47,0x6B,0x97,0xCB,0xE7,0xAB,0x17,0x2B,0x47,0x6B,0x97,0xCB,0xE7,0xAB,
        0x2F,0x4B,0x6F,0x9B,0xCF,0xEB,0xAF,0x7B,0x2F,0x4B,0x6F,0x9B,0xCF,0xEB,0xAF,0x7B,
        0x4F,0x73,0x9F,0xD3,0xEF,0xB3,0x7F,0x53,0x4F,0x73,0x9F,0xD3,0xEF,0xB3,0x7F,0x53,
        0x77,0xA3,0xD7,0xF3,0xB7,0x83,0x57,0x33,0x77,0xA3,0xD7,0xF3,0xB7,0x83,0x57,0x33,
        0xA7,0xDB,0xF7,0xBB,0x87,0x5B,0x37,0x1B,0xA7,0xDB,0xF7,0xBB,0x87,0x5B,0x37,0x1B,
        0xDF,0xFB,0xBF,0x8B,0x5F,0x3B,0x1F,0x0B,0xDF,0xFB,0xBF,0x8B,0x5F,0x3B,0x1F,0x0B,
        0xFF,0xC3,0x8F,0x63,0x3F,0x23,0x0F,0x03,0xFF,0xC3,0x8F,0x63,0x3F,0x23,0x0F,0x03
};

UBYTE OrderedHalftone8[256] =
{
        0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,
        0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,
        0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,
        0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30,
        0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,
        0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,
        0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,
        0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30,
        0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,
        0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,
        0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,
        0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30,
        0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,0x60,0x40,0x90,0xB0,
        0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,0x00,0x20,0xF0,0xD0,
        0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,0x80,0xA0,0x70,0x50,
        0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30,0xE0,0xC0,0x10,0x30
};

UBYTE OrderedHalftone4[256] =
{
        0x90,0xA0,0x98,0x80,0x6C,0x5C,0x64,0x7C,0x90,0xA0,0x98,0x80,0x6C,0x5C,0x64,0x7C,
        0xD8,0xE0,0xE8,0xB0,0x24,0x1C,0x14,0x4C,0xD8,0xE0,0xE8,0xB0,0x24,0x1C,0x14,0x4C,
        0xD0,0xF8,0xF0,0xA8,0x2C,0x04,0x0C,0x54,0xD0,0xF8,0xF0,0xA8,0x2C,0x04,0x0C,0x54,
        0xB8,0xC8,0xC0,0x88,0x44,0x34,0x3C,0x74,0xB8,0xC8,0xC0,0x88,0x44,0x34,0x3C,0x74,
        0x68,0x58,0x60,0x78,0x94,0xA4,0x9C,0x84,0x68,0x58,0x60,0x78,0x94,0xA4,0x9C,0x84,
        0x20,0x18,0x10,0x48,0xDC,0xE4,0xEC,0xB4,0x20,0x18,0x10,0x48,0xDC,0xE4,0xEC,0xB4,
        0x28,0x00,0x08,0x50,0xD4,0xFC,0xF4,0xAC,0x28,0x00,0x08,0x50,0xD4,0xFC,0xF4,0xAC,
        0x40,0x30,0x38,0x70,0xBC,0xCC,0xC4,0x8C,0x40,0x30,0x38,0x70,0xBC,0xCC,0xC4,0x8C,
        0x90,0xA0,0x98,0x80,0x6C,0x5C,0x64,0x7C,0x90,0xA0,0x98,0x80,0x6C,0x5C,0x64,0x7C,
        0xD8,0xE0,0xE8,0xB0,0x24,0x1C,0x14,0x4C,0xD8,0xE0,0xE8,0xB0,0x24,0x1C,0x14,0x4C,
        0xD0,0xF8,0xF0,0xA8,0x2C,0x04,0x0C,0x54,0xD0,0xF8,0xF0,0xA8,0x2C,0x04,0x0C,0x54,
        0xB8,0xC8,0xC0,0x88,0x44,0x34,0x3C,0x74,0xB8,0xC8,0xC0,0x88,0x44,0x34,0x3C,0x74,
        0x68,0x58,0x60,0x78,0x94,0xA4,0x9C,0x84,0x68,0x58,0x60,0x78,0x94,0xA4,0x9C,0x84,
        0x20,0x18,0x10,0x48,0xDC,0xE4,0xEC,0xB4,0x20,0x18,0x10,0x48,0xDC,0xE4,0xEC,0xB4,
        0x28,0x00,0x08,0x50,0xD4,0xFC,0xF4,0xAC,0x28,0x00,0x08,0x50,0xD4,0xFC,0xF4,0xAC,
        0x40,0x30,0x38,0x70,0xBC,0xCC,0xC4,0x8C,0x40,0x30,0x38,0x70,0xBC,0xCC,0xC4,0x8C
};

UBYTE OrderedSpiralDot8[256] =
{
        0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,
        0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,
        0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,
        0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0,
        0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,
        0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,
        0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,
        0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0,
        0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,
        0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,
        0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,
        0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0,
        0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,0x60,0x70,0x80,0x90,
        0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,0x50,0x00,0x10,0xA0,
        0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,0x40,0x30,0x20,0xB0,
        0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0,0xE0,0xE0,0xD0,0xC0
};

UBYTE OrderedSpiralDot4[256] =
{
        0xA8,0xAC,0xB0,0xB4,0xB8,0xBC,0xC0,0xC4,0xA8,0xAC,0xB0,0xB4,0xB8,0xBC,0xC0,0xC4,
        0xA4,0x50,0x54,0x58,0x5C,0x60,0x64,0xC8,0xA4,0x50,0x54,0x58,0x5C,0x60,0x64,0xC8,
        0xA0,0x4C,0x18,0x1C,0x20,0x24,0x68,0xCC,0xA0,0x4C,0x18,0x1C,0x20,0x24,0x68,0xCC,
        0x9C,0x48,0x14,0x00,0x04,0x28,0x6C,0xD0,0x9C,0x48,0x14,0x00,0x04,0x28,0x6C,0xD0,
        0x98,0x44,0x10,0x0C,0x08,0x2C,0x70,0xD4,0x98,0x44,0x10,0x0C,0x08,0x2C,0x70,0xD4,
        0x94,0x40,0x3C,0x38,0x34,0x30,0x74,0xD8,0x94,0x40,0x3C,0x38,0x34,0x30,0x74,0xD8,
        0x90,0x8C,0x88,0x84,0x80,0x7C,0x78,0xDC,0x90,0x8C,0x88,0x84,0x80,0x7C,0x78,0xDC,
        0xF8,0xF8,0xF4,0xF0,0xEC,0xE8,0xE4,0xE0,0xF8,0xF8,0xF4,0xF0,0xEC,0xE8,0xE4,0xE0,
        0xA8,0xAC,0xB0,0xB4,0xB8,0xBC,0xC0,0xC4,0xA8,0xAC,0xB0,0xB4,0xB8,0xBC,0xC0,0xC4,
        0xA4,0x50,0x54,0x58,0x5C,0x60,0x64,0xC8,0xA4,0x50,0x54,0x58,0x5C,0x60,0x64,0xC8,
        0xA0,0x4C,0x18,0x1C,0x20,0x24,0x68,0xCC,0xA0,0x4C,0x18,0x1C,0x20,0x24,0x68,0xCC,
        0x9C,0x48,0x14,0x00,0x04,0x28,0x6C,0xD0,0x9C,0x48,0x14,0x00,0x04,0x28,0x6C,0xD0,
        0x98,0x44,0x10,0x0C,0x08,0x2C,0x70,0xD4,0x98,0x44,0x10,0x0C,0x08,0x2C,0x70,0xD4,
        0x94,0x40,0x3C,0x38,0x34,0x30,0x74,0xD8,0x94,0x40,0x3C,0x38,0x34,0x30,0x74,0xD8,
        0x90,0x8C,0x88,0x84,0x80,0x7C,0x78,0xDC,0x90,0x8C,0x88,0x84,0x80,0x7C,0x78,0xDC,
        0xF8,0xF8,0xF4,0xF0,0xEC,0xE8,0xE4,0xE0,0xF8,0xF8,0xF4,0xF0,0xEC,0xE8,0xE4,0xE0
};

struct MapTable TransferTable[] =
{
	"FILE",		CYID_Transfer_Disk,
	"MEMORY",	CYID_Transfer_Memory,
	"NONE",		CYID_Transfer_None,

	NULL,		-1
};

struct MapTable RenderTable[] =
{
	"FRAME",	CYID_Render_Frame,
	"CLEAR",	CYID_Render_Clear,
	"PLAIN",	CYID_Render_None,

	NULL,		-1
};

VOID (* __regargs WriteLine)(struct RastPort *RPort,LONG Line,LONG Width,UBYTE *Buffer,struct RastPort *Temp);
VOID (* __regargs ReadLine)(struct RastPort *RPort,LONG Line,LONG Width,UBYTE *Buffer,struct RastPort *Temp);
